<!DOCTYPE html>

<html>

<head>
    <title>car race</title>
    <script type="text/javascript" src="libs/three.js"></script>
    <script src="libs/FirstPersonControls.js"></script>
    <script src="libs/OrbitControls.js"></script>
    <script src="libs/TrackballControls.js"></script>
    <script src="libs/KeyboardState.js"></script>
    <script src="libs/Detector.js"></script>
    <script src="libs/THREEx.KeyboardState.js"></script>
    <script type="text/javascript" src="libs/stats.js"></script>
    <script type="text/javascript" src="libs/dat.gui.js"></script>
    <script type="text/javascript" src="libs/ShadowMapViewer.js"></script>
    <script type="text/javascript" src="libs/dat.gui.min.js"></script>
    <script type="text/javascript" src="libs/HDRCubeTextureLoader.js"></script>
    <script type="text/javascript" src="libs/OBJLoader.js"></script>
    <style>
        body {
            /* set margin to 0 and overflow to hidden, to go fullscreen */
            margin: 0;
            overflow: hidden;
        }
    </style>
</head>
<body>


<div id="Stats-output">
</div>
<!-- Div which will hold the Output -->
<div id="WebGL-output">
</div>



<scripts>


    <!-- Javascript code that runs our Three.js examples -->
<script type="text/javascript">


    var collidableMeshList = [];
    var car=new THREE.Mesh();
   // var reflectioncube;
    // var renderer;
    // once everything is loaded, we run our Three.js stuff.


    function init() {

        var stats = initStats();


        let clock = new THREE.Clock();
        let keyboard = new KeyboardState();
        // create a scene, that will hold all our elements such as objects, cameras and lights.
        var scene = new THREE.Scene();

        // create a camera, which defines where we're looking at.
        var camera = new THREE.PerspectiveCamera(55, window.innerWidth / window.innerHeight, 0.9, 1000);
        var controls = new THREE.OrbitControls( camera );
        controls.maxPolarAngle = Math.PI/2;
        controls.mouseButtons = {
            ORBIT: THREE.MOUSE.RIGHT,
            ZOOM: THREE.MOUSE.MIDDLE,
            PAN: THREE.MOUSE.LEFT
        };
        // create a render and set the size
        var renderer = new THREE.WebGLRenderer();

        renderer.setClearColor(new THREE.Color(0xEEEEEE, 1.0));
        renderer.setSize(window.innerWidth, window.innerHeight);
        renderer.shadowMapEnabled = true;
        // create sky box


        var imagePrefix = "texture/skybox/";
        var directions  = ["nx", "ny", "nz", "px", "py", "pz"];
        var imageSuffix = ".JPG";
        var skyGeometry = new THREE.CubeGeometry( 1000, 1000, 1000 );

        var materialArray = [];
        for (var i = 0; i < 6; i++)
            materialArray.push( new THREE.MeshBasicMaterial({
                map: THREE.ImageUtils.loadTexture( imagePrefix + directions[i] + imageSuffix ),
                side: THREE.DoubleSide
            }));
        var skyMaterial = new THREE.MeshBasicMaterial( materialArray );
        var skyBox = new THREE.Mesh( skyGeometry, skyMaterial );
        scene.add( skyBox );

        // new group for merge the scene object
        road = new THREE.Group();
        scene.add(road);

        // create the street
        var streetTexture = new THREE.ImageUtils.loadTexture( 'texture/Road-Texture.jpg' );
        streetTexture.wrapS = THREE.RepeatWrapping;
        streetTexture.repeat.x=2;
        streetTexture.opacity = 15 ;
        var streetGeometry = new THREE.PlaneGeometry(6000, 100, 1, 1);
        var streetMaterial = new THREE.MeshLambertMaterial({map: streetTexture,
            side: THREE.DoubleSide,
            color: 0xffffff});
        var street = new THREE.Mesh(streetGeometry, streetMaterial);
        street.receiveShadow = true;

        // rotate and position the street
        street.rotation.x = -0.5 * Math.PI;
        street.position.x = 3000;
        street.position.y = 0;
        street.position.z = 0;

        // add the street to the scene or road
        //scene.add(street);
        road.add(street);

        // create texture of both side of street
        var sideTexture = new THREE.ImageUtils.loadTexture( 'texture/incomplete.jpg' );
        sideTexture.wrapS = THREE.RepeatWrapping;
        sideTexture.wrapT = THREE.RepeatWrapping;
        sideTexture.repeat.set(1000,-10);

        // create the left side of street
        var LsideGeometry = new THREE.PlaneGeometry(6000, 40, 1, 1);
        var LsideMaterial = new THREE.MeshLambertMaterial({
            map: sideTexture,
            side: THREE.DoubleSide,
            color: 0000080});
        var Lside = new THREE.Mesh(LsideGeometry, LsideMaterial);
        Lside.receiveShadow = true;

        // rotate and position the Left side
        Lside.rotation.x = -0.5 * Math.PI;
        Lside.position.x = 3000;
        Lside.position.y = 0;
        Lside.position.z = -70;

        // add the Left side to the scene
        //scene.add(Lside);
        road.add(Lside);

        // create the right side of street
        var RsideGeometry = new THREE.PlaneGeometry(6000, 40, 1, 1);
        var RsideMaterial = new THREE.MeshLambertMaterial({
            map: sideTexture,
            side: THREE.DoubleSide,
            color: 0x0000ff});
        var Rside = new THREE.Mesh(RsideGeometry, RsideMaterial);
        Rside.receiveShadow = true;

        // rotate and position the Right side
        Rside.rotation.x = -0.5 * Math.PI;
        Rside.position.x = 3000;
        Rside.position.y = 0;
        Rside.position.z = 70;

        // add the Right side to the scene
        //scene.add(Rside);
        road.add(Rside);


        // new group for merge the car area and car obj
         var player = new THREE.Group();
         scene.add(player);

        // create a car area

        //Spher
        var carSphereGeometry = new THREE.SphereGeometry(5, 2, 2);
        var carboxMaterial = new THREE.MeshBasicMaterial({
            wireframe:false,
            transparent:true,
            opacity:0,
            color: 0xffffff});
        var carbox = new THREE.Mesh(carSphereGeometry, carboxMaterial);
        carbox.castShadow = false;

        //box
        {
        var carBoxGeometry = new THREE.BoxGeometry(5, 2, 2);
        var carboxMaterial = new THREE.MeshBasicMaterial({
            wireframe:false,
            transparent:true,
            opacity:5,
            color: 0xff1fff});
        var carbox = new THREE.Mesh(carSphereGeometry, carboxMaterial);
        carbox.castShadow = false;}
        //Torus
        {
            var carBoxGeometry = new THREE.TorusGeometry(4, 1, 1,2);
            var carboxMaterial = new THREE.MeshBasicMaterial({
                wireframe:false,
                transparent:true,
                opacity:10,
                color: 0xff1fff});
            var carbox = new THREE.Mesh(carSphereGeometry, carboxMaterial);
            carbox.castShadow = false;}

        {
            var carBoxGeometry = new THREE.PlaneGeometry(5, 20, 32);
            var carboxMaterial = new THREE.MeshBasicMaterial({
                wireframe:false,
                transparent:true,
                opacity:5,
                color: 0xff1fff});
            var carbox = new THREE.Mesh(carSphereGeometry, carboxMaterial);
            carbox.castShadow = false;}

        // position the player
        carbox.position.x = 25;
        carbox.position.y = 5;
        carbox.position.z = 0;

        // add the player to the scene
        //scene.add(carbox);
        player.add(carbox);

        /////  car's head light
        var Lspotlight = new THREE.SpotLight(0xfccb08);
        Lspotlight.position.set( 65, 2, 9);
        player.add(Lspotlight);

        var Rspotlight = new THREE.SpotLight(0xfccb08);
        Rspotlight.position.set( 65, 2, -9);
        player.add(Rspotlight);



        //Barrier or other objects or cars
        var BarrierGeometry = new THREE.SphereGeometry( 30, 10, 15 );
        var BarrierMaterial = new THREE.MeshBasicMaterial( { color: 820042,
            wireframe:false,
            transparent : true,

            opacity : 25 } );
        var Barrier = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier.position.set(300, 5, 20);
        collidableMeshList.push(Barrier);
        road.add(Barrier);

        var Barrier1 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier1.position.set(500, 5, -20);
        collidableMeshList.push(Barrier1);
        road.add(Barrier1);


        var Barrier2 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier2.position.set(650, 5, 20);
        collidableMeshList.push(Barrier2);
        road.add(Barrier2);


        var Barrier3 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier3.position.set(780, 5, -20);
        collidableMeshList.push(Barrier3);
        road.add(Barrier3);



        var Barrier4 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier4.position.set(900, 5, 25);
        collidableMeshList.push(Barrier4);
        road.add(Barrier4);

        var Barrier20 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier20.position.set(1000, 5, 33);
        collidableMeshList.push(Barrier20);
        road.add(Barrier20)


        ////////////////////////////////////////box geometry/////////////////////////////////////////////
        var BarrierGeometry = new THREE.BoxGeometry( 50, 20, 25 );
        var BarrierMaterial = new THREE.MeshBasicMaterial( { color: 0o00000,
            wireframe:false,
            transparent : true,
            opacity : 25 } );
        var Barrier5 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier5.position.set(400, 5,-25);
        collidableMeshList.push(Barrier5);
        road.add(Barrier5);

        var Barrier6 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier6.position.set(560, 5, 45);
        collidableMeshList.push(Barrier6);
        road.add(Barrier6);


        var Barrier7 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier7.position.set(721, 5, 29);
        collidableMeshList.push(Barrier7);
        road.add(Barrier7);

        var Barrier8 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier8.position.set(850,5,-36);
        collidableMeshList.push(Barrier8);
        road.add(Barrier8);

      /////////////////////////////////////// Torus ////////////////////////
        var BarrierGeometry = new THREE.TorusGeometry( 20, 10, 5,5 );
        var BarrierMaterial = new THREE.MeshBasicMaterial( { color: 300018,
            wireframe:false,
            transparent : true,
            opacity : 30 } );

        var Barrier9 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier9.position.set(90, 5,-35,5);
        collidableMeshList.push(Barrier9);
        road.add(Barrier9);


        var Barrier10 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier10.position.set(1000, 5,-40,5);
        collidableMeshList.push(Barrier10);
        road.add(Barrier10);

        var Barrier11 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier11.position.set(1050, 5, -30,5);
        collidableMeshList.push(Barrier11);
        road.add(Barrier11);

        var Barrier12 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier12.position.set(1100, 5, -20,5);
        collidableMeshList.push(Barrier12);
        road.add(Barrier12);


        var Barrier13 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier13.position.set(1150, 5, -10,5);
        collidableMeshList.push(Barrier13);
        road.add(Barrier13);

        var Barrier14 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier14.position.set(1200, 5, 2,5);
        collidableMeshList.push(Barrier14);
        road.add(Barrier14);

        var Barrier15 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier15.position.set(1250, 5, 12,5);
        collidableMeshList.push(Barrier15);
        road.add(Barrier15);

        var Barrier16 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier16.position.set(1300, 5, 22,5);
        collidableMeshList.push(Barrier16);
        road.add(Barrier16);

        var Barrier17 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier17.position.set(1350, 5, 36,5);
        collidableMeshList.push(Barrier17);
        road.add(Barrier17);

        var Barrier18 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier18.position.set(950, 5, -50,5);
        collidableMeshList.push(Barrier18);
        road.add(Barrier18);

        var Barrier19 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier19.position.set(900, 5, -55,5);
        collidableMeshList.push(Barrier19);
        road.add(Barrier19);

        var Barrier21 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier21.position.set(1400, 5,42,5);
        collidableMeshList.push(Barrier21);
        road.add(Barrier21);
      //////////////////////////////////////////////////////////////////////////////////////////////

        var BarrierGeometry = new THREE.Geometry( 50, 20, 25 );
        var BarrierMaterial = new THREE.MeshBasicMaterial( { color: 0x1050ff,
            wireframe:false,
            transparent : true,
            opacity : 25 } );

        var Barrier21 = new THREE.Mesh(BarrierGeometry, BarrierMaterial);
        Barrier20.position.set(1050, 5, 10);
        collidableMeshList.push(Barrier20);
        road.add(Barrier20)

        ///////////////////////////////// SIDE COLLISION /////////////


        var SideBarrierGeometry = new THREE.BoxGeometry( 5500, 40, 1);
        var SideBarrierMaterial = new THREE.MeshBasicMaterial( { color: 0x0b0fff,
            wireframe:false,
            transparent : true,
            opacity : 25} );
        var LSideBarrier = new THREE.Mesh(SideBarrierGeometry, SideBarrierMaterial);
        LSideBarrier.position.set(2750, 0, -70);
        collidableMeshList.push(LSideBarrier);
        road.add(LSideBarrier);

        var RSideBarrier = new THREE.Mesh(SideBarrierGeometry, SideBarrierMaterial);
        RSideBarrier.position.set(2750, 0, 70);
        collidableMeshList.push(RSideBarrier);
        road.add(RSideBarrier);



        ////////////////////////////////////// create a car ***********************************************
        var objectloader = new THREE.ObjectLoader();
        objectloader.load("model/camero-2010-low-poly-threejs/camero-2010-low-poly.json",
            function (obj) {
            car = obj.clone();
            car.scale.set(15,15,15);
            car.position.set(23,0,0);
            car.rotation.y = 67.5 * Math.PI;
            car.castShadow = true;
            //scene.add(car);
            player.add(car);
        });

        // position and point the camera to the scene
        camera.position.x = -155;
        camera.position.y = 70;
        camera.position.z = 0;
        camera.lookAt(new THREE.Vector3(200, 10, 10));

        // add subtle ambient lighting
        var ambiColor = "#fff8f1";
        var ambientLight = new THREE.AmbientLight(ambiColor);
        scene.add(ambientLight);


        // var target = {x:0,y:0,z:0};
        // var tween = new TWEEN.Tween(street.position).to(target,15000);
        // tween.delay(1000);
        // tween.easing(TWEEN.Linear.None);

        // add the output of the renderer to the html element
        document.getElementById("WebGL-output").appendChild(renderer.domElement);

        // call the render function

        scene.fog = new THREE.FogExp2(0xccccc,0.0015);

        // audioLoader = new THREE.AudioLoader();
        // var listener = new THREE.AudioListener();
        // camera.add( listener );
        //
        // var soundX = new THREE.PositionalAudio(listener);
        // audioLoader.load('sound/soundx.mp3',function (buffer) {
        //     soundX.setBuffer( buffer );
        //     soundX.setRefDistance( 15 );
        //     soundX.play();
        // });
        // scene.add(soundX);
        render();

        function render() {
            stats.update();
            controls.update();
            //TWEEN.update();

            // using keyboard for moving the car to left and right
            keyboard.update();
            var moveDistance = 100 * clock.getDelta();

            if ( keyboard.pressed("W") || keyboard.pressed("left") )
                carbox.translateZ( -moveDistance );

            if ( keyboard.pressed("E") || keyboard.pressed("right") )
                carbox.translateZ(  moveDistance );

            if ( keyboard.pressed("W") || keyboard.pressed("left") )
                player.translateZ( -moveDistance );

            if ( keyboard.pressed("E") || keyboard.pressed("right") )
                player.translateZ(  moveDistance );

            // for road moving

            var time = Date.now();
            road.position.x -=2.45;
            road.position.y -=-0.0019;



            // detecting collision
            var originPoint = carbox.position.clone();

            for (var vertexIndex = 5; vertexIndex < carbox.geometry.vertices.length; vertexIndex++)
            {
                var localVertex = carbox.geometry.vertices[vertexIndex].clone();
                var globalVertex = localVertex.applyMatrix4( carbox.matrix );
                var directionVector = globalVertex.sub( carbox.position );

                var ray = new THREE.Raycaster( originPoint, directionVector.clone().normalize() );
                var collisionResults = ray.intersectObjects( collidableMeshList );
                if ( collisionResults.length > 0 && collisionResults[0].distance < directionVector.length() )
                {

                    ambientLight.color = 820042;
                    road.position = onpause();
                }

            }


            // render using requestAnimationFrame
            requestAnimationFrame(render);
            renderer.render(scene, camera);
        }

        function initStats() {

            var stats = new Stats();

            stats.setMode(0); // 0: fps, 1: ms

            // Align top-left
            stats.domElement.style.position = 'absolute';
            stats.domElement.style.left = '5px';
            stats.domElement.style.top = '5px';

            document.getElementById("Stats-output").appendChild(stats.domElement);

            return stats;
        }
    }

    window.onload = init


</script>
</body>
</html>